=========
ATTENTION
=========

This is a performance test tool in the making. **Nothing you would want to use at the moment!**

Currently the intention of the tool is to automate the steps like (preparation, execution and results analysis). The steps are initiated on the console. Don't worry at a later stage the whole roundtrip will be automated.

Currently start and termination of the EC2 instances are manual processes as well. At the beginning of a test start the two instances on EC2 and add the instance ids to the environment.ini file. Provide a bigger CPU for the load generator! Do not forget to terminate the EC2 instances after you are done. 


What is this?
=============

aogaeru is a tool to performance test a single page application (SPA)

Currently it is just a prototype to show that it can be done.


Install it
==========

pip install aogaeru

aogaeru provides a seed configuration that you may use to setup your own load testing projects. aogaeru also provides a sample configuration so you can performance test the supercar application on amazon EC2.

Note: at the current stage aogaeru package is not implemented yet. You must use the tools like rtcl, load, korg and plot directly.


Overview
========

The aogaeru scales up on multiple AMI instances and up to 1000 virtual users.

![Overview aogaeru performance testing tools](/doc/overview/aogaeru.png)

aogaeru consists of multiple independent tools so you can assemble a tool stack that fits your needs / liking.

You need an internet connection to be able to connect to the Amazon EC2 instances. If you are behind a corporate firewall you will need to setup your toolstack in a way that you are able to connect to the internet. Usually you will need to use / configure your corporate proxy to archive this.


ssh into the instance
---------------------

ssh -i config/mfinkkey.pem ubuntu@ec2-54-229-222-252.eu-west-1.compute.amazonaws.com


prepare the SUT
---------------

rctl -e config/mark_ec2.ini -r deploy_supercars -H supercars

rctl -e config/mark_ec2.ini -r deploy_counters -H supercars

rctl -e config/mark_ec2.ini -r start_supercars -H supercars

To make sure the supercars app is running visit with your browser the url http://<your ami url>:8000/
e.g. http://ec2-54-229-179-157.eu-west-1.compute.amazonaws.com:8000/

Add the SUT url to your Loadmodel.json configuration:
"Configuration": {
    "url": "http://ec2-54-229-205-77.eu-west-1.compute.amazonaws.com:8000"
},


prepare the load generator grid
-------------------------------

rctl -e config/mark_ec2.ini -r deploy_selenium -H load-generator

rctl -e config/mark_ec2.ini -r deploy_phantomjs -H load-generator

rctl -e config/mark_ec2.ini -r start_hub -H load-generator

rctl -e config/mark_ec2.ini -r start_phantomjs -H load-generator

Visit the hub to see if all phantomjs nodes have ramped up correctly. Direct your browser to http://<your ami url>:4444/grid/console
e.g. http://ec2-54-229-169-192.eu-west-1.compute.amazonaws.com:4444/grid/console

Now add the grid hub to your Loadmodel.json configuration:
"Configuration": {
    "hub": "http://ec2-54-229-180-39.eu-west-1.compute.amazonaws.com:4444/wd/hub"
},


start the test
--------------

initialize the os counters:

rctl -e config/mark_ec2.ini -H supercars -r start_oscounters -a 2000

engage:

load scenarios/supercars/Loadmodel.json


collect the test results
------------------------

rctl -e config/mark_ec2.ini -r collect_oscounters -H supercars

also get the results.csv file from the base directory of your test.

